/*
 *  $Id: main.cpp,v 1.1.1.1 2002/11/09 15:43:50 omalley Exp $ 
 *  Copyright (c) 2002 Kevin O'Malley. All rights reserved.
 *
 *  Example program from "Programming Mac OS X: A Guide for
 *  UNIX Developers" by Kevin O'Malley, Manning Publishing
 *  2002.
 *
 *  An example program that drives two implementations of the
 *  Fibonacci number series.  To run a version, click on
 *  the Targets tab and select the appropriate target -
 *  recursive or loop (iterative).
 * 
 *  For more information on Fibonacci and the series see:
 * 
 *   - http://www.mcs.surrey.ac.uk/Personal/R.Knott/Fibonacci/fib.html
 *   - http://www-gap.dcs.st-and.ac.uk/~history/Mathematicians/Fibonacci.html
 *   - http://math.holycross.edu/~davids/fibonacci/fibonacci.html
 */
using namespace std;
#include <iostream>

#include "FibonacciRecursive.h"
#include "FibonacciLoop.h"

const int N_FIBONACCI_NUMS = 10;

int
main()
{
  long fibonacciResult[N_FIBONACCI_NUMS];
    
  for(int i=0; i<N_FIBONACCI_NUMS; i++) {
    fibonacciResult[i] = Fibonacci(i);
  }

  cout << "Computed Fibonacci values:" << endl;
  for(int i=0; i<N_FIBONACCI_NUMS; i++) {
    cout << "fib(" << i << ") = "
         << fibonacciResult[i] << endl;
  }  
  return 0;
}
