/*
 *  $Id: FastRead.cpp,v 1.2 2003/01/05 12:36:56 omalley Exp $
 *  Copyright (c) 2002 Kevin O'Malley. All rights reserved.
 *
 *  Example program from "Programming Mac OS X: A Guide for
 *  UNIX Developers" by Kevin O'Malley, Manning Publishing
 *  2002.
 */
#include <cstdio>
#include <cstdlib>
#include <cstring>
#include <cerrno>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <netdb.h>
#include <fcntl.h>
#include <unistd.h>

#include "FastRead.h"

/*
 Read a message from the socket.  This function is based on code from
 Stevens's "W. R. Stevens, UNIX network programming, 2nd ed. Upper
 Saddle River, NJ: Prentice Hall PTR, 1998."
 */
int
ReadString(int fd, char *ptr, int maxlen)
{
again:

  int nRead = read(fd, ptr, maxlen);
  if (nRead < 0) {
    /*
     Test for system call begin interupted by caught signal.
     We handle the error rather than the caller.
     */
    if (errno == EINTR) {
      goto again;
    }
  }
  return nRead;
}
