#!/usr/bin/perl -w
#  $Id: send.pl,v 1.1.1.1 2002/11/09 15:43:55 omalley Exp $ 
#  Copyright (c) 2002 Kevin O'Malley. All rights reserved.
# 
#  Example program from "Programming Mac OS X: A Guide for
#  UNIX Developers" by Kevin O'Malley, Manning Publishing
#  2002.
#

use strict;
use IO::Socket;

if (@ARGV != 5) {
	print"send ver. 1.0\n";
	print "Copyright (c) 2002 Kevin O'Malley\n";
	print "usage: send [iterations] [sleep between sends (secs)]";
	print " [server] [port] [message]\n";
	exit;
}

my ($max, $sleep_secs, $host, $port, $str) = @ARGV;

for(my $i=0; $i<$max; $i++) {
	print "pass: $i\n";
	process($sleep_secs, $host, $port, $str);
	print "\n";
}

sub process {
	my($sleep_secs, $host, $port, $str) = @_;
	
	my $sock = IO::Socket::INET->new(Proto     => "tcp",
					 PeerAddr  => $host,
					 PeerPort  => $port);
	
	$sock->autoflush(1) if $sock;   # so output gets there right away
	
	my $line = $str;
	$line .= "\0";
	print "sending: $line\n";
	print $sock $line;

	my $byte = "";
	my $s = "";
	while(sysread($sock, $byte, 1) == 1 && $byte ne "\0") {  
		$s .= $byte;
	}
	print "received: $s\n";
	
	sleep($sleep_secs);
	close($sock);
}

