/*
 *  $Id: auction.m,v 1.1.1.1 2002/11/09 15:43:57 omalley Exp $
 *  Copyright (c) 2002 Kevin O'Malley. All rights reserved.
 *
 *  Example program from "Programming Mac OS X: A Guide for
 *  UNIX Developers" by Kevin O'Malley, Manning Publishing
 *  2002.
 */
#import "auction.h"

@implementation auction

- (id) init {
  self = [super init];
  activeBids = [[NSMutableDictionary alloc] init];

  return self;
}

- (void) dealloc {
  [activeBids release];
  [super dealloc];
}

-(BOOL) addBid:(NSString *) ownerID: (NSString *)bidStr {
  if ( (ownerID == nil) || (bidStr == nil) )
    return NO;
  
  [activeBids setObject: bidStr
                forKey:  ownerID];
  return YES;
}

-(void)print {
  NSArray *keys;
  id key, value;
  int i;

  keys = [activeBids allKeys];
  NSLog(@"Size: %d", [keys count]);
  for (i=0; i<[keys count]; i++) {
    key = [keys objectAtIndex: i];
    value = [activeBids objectForKey: key];
    NSLog(@"Key: %@ for value: %@", key, value);
  }
}

@end
