/*
 *  $Id: AppSupport.m,v 1.1.1.1 2002/11/09 15:44:02 omalley Exp $
 *  Copyright (c) 2002 Kevin O'Malley. All rights reserved.
 *
 *  Example program from "Programming Mac OS X: A Guide for
 *  UNIX Developers" by Kevin O'Malley, Manning Publishing
 *  2002.
 */
#import "AppSupport.h"


@implementation AppSupport

+ (NSString *) getFilename:(NSString *)title
{
  NSString *s = @"";
  NSOpenPanel *panel;
  int result;
  panel = [NSOpenPanel openPanel];
  [panel setCanChooseFiles:TRUE];
  [panel setCanChooseDirectories:FALSE];
  [panel setAllowsMultipleSelection:FALSE];
  [panel setTitle:title];
  result = [panel runModalForDirectory:NSHomeDirectory() file:nil types:nil];
  if(result == NSOKButton) {
    NSArray *retArray = [panel filenames];
    s = [NSString stringWithFormat:@"%@", [retArray objectAtIndex:0]];
  }
  return s;
}

+ (NSString *) getDirectory:(NSString *)title
{
  NSString *s = @"";
  int result;
  NSOpenPanel *panel;
  panel = [NSOpenPanel openPanel];
  [panel setCanChooseFiles:FALSE];
  [panel setCanChooseDirectories:TRUE];
  [panel setAllowsMultipleSelection:FALSE];
  [panel setTitle:title];
  result = [panel runModalForDirectory:NSHomeDirectory() file:nil types:nil];
  if(result == NSOKButton) {
    NSArray *retArray = [panel filenames];
    s = [NSString stringWithFormat:@"%@", [retArray objectAtIndex:0]];
  }
  return s;  
}

+ (NSString *)getSaveFile:(NSString *)title
{
  NSString *s = @"";
  int result;
  NSSavePanel *panel = [NSSavePanel savePanel];
  [panel setRequiredFileType:@"plist"];
  [panel setTitle:title];
  result = [panel runModal];
  if (result == NSOKButton) {
    s = [panel filename];
  }
  return s;
}

+ (void)setStatusMsgWithDate:(NSTextView *)statusField theMsg:(NSString *)msg
{
  [statusField insertText:[NSString stringWithFormat:@"%@: ", [NSCalendarDate date]]];
  [statusField insertText:[NSString stringWithFormat:@"%@\n", msg]];
}

+ (void)scrollStatus:(NSTextView *)statusField
{
  [statusField scrollRangeToVisible:NSMakeRange([[statusField string] length], 0)];
}

@end
