/*
 *  $Id: CocoaWGetController_new.h,v 1.2 2003/01/05 12:44:22 omalley Exp $
 *  Copyright (c) 2002 Kevin O'Malley. All rights reserved.
 *
 *  Example program from "Programming Mac OS X: A Guide for
 *  UNIX Developers" by Kevin O'Malley, Manning Publishing
 *  2002.
 */
#import <Cocoa/Cocoa.h>
#import "LIMController.h"
#import "WGetParameters.h"
#import "DownloadController.h"
#import "RRController.h"
#import "TaskWrapper.h"

@interface CocoaWGetController : NSObject <TaskWrapperController>
{
	IBOutlet id downloadController;
	IBOutlet id htmlFtpController;
	IBOutlet id limController;
	IBOutlet id retrievalController;
	IBOutlet NSTextView *theStatus;
	IBOutlet NSTextField *url;
	IBOutlet NSWindow *mainWindow;
	IBOutlet NSWindow *downloadWindow;

  IBOutlet NSButton *getButton;
  NSString *directory;
	WGetParameters *param;
  BOOL retrievalInProgress;
  TaskWrapper *task;
}

- (IBAction)handleDownload:(id)sender;
- (IBAction)handleOpen:(id)sender;
- (IBAction)handleReset:(id)sender;
- (IBAction)handleSave:(id)sender;
- (IBAction)handleViewParams:(id)sender;

- (void)reset:(id)sender;
- (void)raiseSheet;
- (void)closeSheet:(id)sender;
- (void)displayCmdLine:(NSString *)headerStr;

@end
