/*
 *  $Id: HtmlFtpController.m,v 1.1.1.1 2002/11/09 15:44:02 omalley Exp $
 *  Copyright (c) 2002 Kevin O'Malley. All rights reserved.
 *
 *  Example program from "Programming Mac OS X: A Guide for
 *  UNIX Developers" by Kevin O'Malley, Manning Publishing
 *  2002.
 */
#import "HtmlFtpController.h"

@implementation HtmlFtpController

- (IBAction)handleSaveCookies:(id)sender
{
}

- (IBAction)handleSetLoadCookies:(id)sender
{
}

- (IBAction)reset:(WGetParameters *)param
{
  [[cookiesForm cellAtIndex:Log] setStringValue:[param getValue:@"--load-cookies="]];
  [[cookiesForm cellAtIndex:Save] setStringValue:[param getValue:@"--save-cookies="]];

  [[headersForm cellAtIndex:Define] setStringValue:[param getValue:@"--header="]];
  [[headersForm cellAtIndex:Include] setStringValue:[param getValue:@"--referer="]];

  [agentString setStringValue:[param getValue:@"--user-agent="]];

  if ([[param getValue:@"--html-extension"] isEqualToString:@"1"])
    [addHtmlExt setState:NSOnState];
  else
    [addHtmlExt setState:NSOffState];

  if ([[param getValue:@"--no-http-keep-alive"] isEqualToString:@"1"])
    [disablePersistentHtml setState:NSOnState];
  else
    [disablePersistentHtml setState:NSOffState];

  if ([[param getValue:@"--cache"] isEqualToString:@"1"])
    [disableServerCache setState:NSOnState];
  else
    [disableServerCache setState:NSOffState];

  if ([[param getValue:@"--dont-remove-listing"] isEqualToString:@"1"])
    [doNotRemoveListingFile setState:NSOnState];
  else
    [doNotRemoveListingFile setState:NSOffState];

  if ([[param getValue:@"--cache="] isEqualToString:@"1"])
    [getFilesfromRemoteSite setState:NSOnState];
  else
    [getFilesfromRemoteSite setState:NSOffState];

  if ([[param getValue:@"--ignore-length"] isEqualToString:@"1"])
    [ignoreContentLengthHeader setState:NSOnState];
  else
    [ignoreContentLengthHeader setState:NSOffState];

  if ([[param getValue:@"--retr-symlinks"] isEqualToString:@"1"])
    [retierveFilesfromLinks setState:NSOnState];
  else
    [retierveFilesfromLinks setState:NSOffState];

  if ([[param getValue:@"--save-headers"] isEqualToString:@"1"])
    [saveHeaders setState:NSOnState];
  else
    [saveHeaders setState:NSOffState];

  if ([[param getValue:@"--glob="] isEqualToString:@"1"])
    [turnOffWildcards setState:NSOnState];
  else
    [turnOffWildcards setState:NSOffState];

  if ([[param getValue:@"--passive-ftp"] isEqualToString:@"1"])
    [usePassiveFtp setState:NSOnState];
  else
    [usePassiveFtp setState:NSOffState];

  if ([[param getValue:@"--passive-ftp"] isEqualToString:@"1"])
    [disableCookies setState:NSOnState];
  else
    [disableCookies setState:NSOffState];
}

- (void)getParameters:(WGetParameters *)param
{
  NSString *s;

  [param setValue:@"--load-cookies=":[[cookiesForm cellAtIndex:Log] stringValue]];
  [param setValue:@"--save-cookies=":[[cookiesForm cellAtIndex:Save] stringValue]];
  [param setValue:@"--header=":[[headersForm cellAtIndex:Define] stringValue]];
  [param setValue:@"--referer=":[[headersForm cellAtIndex:Include] stringValue]];
  
  [param setValue:@"--user-agent=":[agentString stringValue]];

  [param setValue:@"--html-extension":[NSString stringWithFormat:@"%d", [addHtmlExt state]]];

  s = [NSString stringWithFormat:@"%d", [disableCookies state]];
  if ([s isEqualToString:@"1"])
    [param setValue:@"--cookies=":@"off"];
  else
    [param setValue:@"--cookies=":@"on"];
    
  [param setValue:@"--no-http-keep-alive":[NSString stringWithFormat:@"%d", [disablePersistentHtml state]]];
  [param setValue:@"--dont-remove-listing":[NSString stringWithFormat:@"%d", [doNotRemoveListingFile state]]];


  s = [NSString stringWithFormat:@"%d", [getFilesfromRemoteSite state]];
  if ([s isEqualToString:@"1"])
    [param setValue:@"--cache=":@"on"];
  else
    [param setValue:@"--cache=":@"off"];
  
  [param setValue:@"--ignore-length":[NSString stringWithFormat:@"%d", [ignoreContentLengthHeader state]]];
  [param setValue:@"--retr-symlinks":[NSString stringWithFormat:@"%d", [retierveFilesfromLinks state]]];
  [param setValue:@"--save-headers":[NSString stringWithFormat:@"%d", [saveHeaders state]]];

  s = [NSString stringWithFormat:@"%d", [turnOffWildcards state]];
  if ([s isEqualToString:@"1"])
    [param setValue:@"--glob=":@"on"];
  else
    [param setValue:@"--glob=":@"off"];
  
  [param setValue:@"--passive-ftp":[NSString stringWithFormat:@"%d", [usePassiveFtp state]]];
}

@end
