/*
 *  $Id: LIMController.h,v 1.1.1.1 2002/11/09 15:44:02 omalley Exp $
 *  Copyright (c) 2002 Kevin O'Malley. All rights reserved.
 *
 *  Example program from "Programming Mac OS X: A Guide for
 *  UNIX Developers" by Kevin O'Malley, Manning Publishing
 *  2002.
 */
#import <Cocoa/Cocoa.h>
#import "WGetParameters.h"

@interface LIMController : NSObject
{
    IBOutlet NSTextField *extraCommands;
    IBOutlet NSForm *inputForm;
    IBOutlet NSForm *logMsgForm;
    IBOutlet NSButton *printDebugInfo;
    IBOutlet NSTextField *rawCommand;
    IBOutlet NSButton *treatInputFileAsHTML;
    IBOutlet NSButton *turnOffOutput;
    IBOutlet NSButton *turnVerboseOn;
}
- (IBAction)handleSetAppendMsgTo:(id)sender;
- (IBAction)handleSetDownloadUrlFrom:(id)sender;
- (IBAction)handleSetLogMsgTo:(id)sender;
- (IBAction)reset:(WGetParameters *)param;
- (void)getParameters:(WGetParameters *)param;

enum LoggingForm {
  LogMsgTo = 0,
  AppendMsgTo
};

enum InputForm {
  DownloadUrlFrom = 0,
  PrependLinksWith
};

@end
