/*
 *  $Id: LIMController.m,v 1.1.1.1 2002/11/09 15:44:02 omalley Exp $
 *  Copyright (c) 2002 Kevin O'Malley. All rights reserved.
 *
 *  Example program from "Programming Mac OS X: A Guide for
 *  UNIX Developers" by Kevin O'Malley, Manning Publishing
 *  2002.
 */
#import "LIMController.h"
#import "AppSupport.h"

@implementation LIMController

- (IBAction)handleSetAppendMsgTo:(id)sender
{
  [[logMsgForm cellAtIndex:AppendMsgTo] setStringValue:[AppSupport getFilename:@"Append Messages to File"]];
}

- (IBAction)handleSetDownloadUrlFrom:(id)sender
{
  [[inputForm cellAtIndex:DownloadUrlFrom] setStringValue:[AppSupport getFilename:@"Download URL's from File"]];
}

- (IBAction)handleSetLogMsgTo:(id)sender
{
  [[logMsgForm cellAtIndex:LogMsgTo] setStringValue:[AppSupport getFilename:@"Log Messages to File"]];
}

- (IBAction)reset:(WGetParameters *)param
{
  [[logMsgForm cellAtIndex:LogMsgTo] setStringValue:[param getValue:@"--output-file="]];
  [[logMsgForm cellAtIndex:AppendMsgTo] setStringValue:[param getValue:@"--append-output="]];

  [[inputForm cellAtIndex:DownloadUrlFrom] setStringValue:[param getValue:@"--input-file="]];
  [[inputForm cellAtIndex:PrependLinksWith] setStringValue:[param getValue:@"--base="]];

  [extraCommands setStringValue:[param getValue:@"extra-commands"]];

  if ([[param getValue:@"--force-html="] isEqualToString:@"1"])
    [printDebugInfo setState:NSOnState];
  else
    [printDebugInfo setState:NSOffState];

  if ([[param getValue:@"--debug"] isEqualToString:@"1"])
    [treatInputFileAsHTML setState:NSOnState];
  else
    [treatInputFileAsHTML setState:NSOffState];

  if ([[param getValue:@"--quiet"] isEqualToString:@"1"])
    [turnOffOutput setState:NSOnState];
  else
    [turnOffOutput setState:NSOffState];

  if ([[param getValue:@"--verbose"] isEqualToString:@"1"])
    [turnVerboseOn setState:NSOnState];
  else
    [turnVerboseOn setState:NSOffState];
  
  [rawCommand setStringValue:[param getValue:@"raw-command"]];
}

- (void)getParameters:(WGetParameters *)param
{
  [param setValue:@"--output-file=":[[logMsgForm cellAtIndex:LogMsgTo] stringValue]];
  [param setValue:@"--append-output=":[[logMsgForm cellAtIndex:AppendMsgTo] stringValue]];
  
  [param setValue:@"--input-file=":[[inputForm cellAtIndex:DownloadUrlFrom] stringValue]];
  [param setValue:@"--base=":[[inputForm cellAtIndex:PrependLinksWith] stringValue]];

  [param setValue:@"extra-commands":[extraCommands stringValue]];


  [param setValue:@"--force-html=":[NSString stringWithFormat:@"%d", [treatInputFileAsHTML state]]];
  [param setValue:@"--debug":[NSString stringWithFormat:@"%d", [printDebugInfo state]]];
  [param setValue:@"--quiet":[NSString stringWithFormat:@"%d", [turnOffOutput state]]];
  [param setValue:@"--verbose":[NSString stringWithFormat:@"%d", [turnVerboseOn state]]];

  [param setValue:@"raw-command":[rawCommand stringValue]];
}

@end
