/*
 *  $Id: MyTask.m,v 1.1.1.1 2002/11/09 15:44:02 omalley Exp $
 *  Copyright (c) 2002 Kevin O'Malley. All rights reserved.
 *
 *  Example program from "Programming Mac OS X: A Guide for
 *  UNIX Developers" by Kevin O'Malley, Manning Publishing
 *  2002.
 */
#import "MyTask.h"

@implementation MyTask

-(id)init
{
  self = [super init];
	m_taskOutput = [[NSMutableString alloc] initWithString:@""];
  return self;
}

- (void) dealloc
{
	[super dealloc];

  [m_taskOutput release];
}


- (void)runTask:(NSString *)taskName
   theDirectory:(NSString *)dir
       theArgs:(NSMutableArray *)args
       getOutputFrom:(int)outType;
{
	NSPipe *pipe = [NSPipe pipe];
	NSFileHandle *readHandle = [pipe fileHandleForReading];
	NSData *inData = nil;
	
  // Save the input parameters.
	m_taskName = taskName;
	m_directory = dir;
	m_args = args;

	/*
	 Allocate and init the task and set the task's environment to
	 the values passed to the method. 
	 */
  task = [[NSTask alloc] init];

	[task setCurrentDirectoryPath:dir];

  if (outType == 0)
    [task setStandardOutput:pipe];
  else
    [task setStandardError:pipe];

  [task setLaunchPath:taskName];
  [task setArguments:args];
  [task launch];
	while ((inData = [readHandle availableData]) && [inData length]) {
		NSString *s = [[NSString alloc] initWithData:inData encoding:NSASCIIStringEncoding];
    NSLog(@"%@\n", s);
		[m_taskOutput appendString:[NSString stringWithFormat:@"%@ ", s]];
    [s release];
	}
  // m_exitStatus = [task terminationStatus];
  [task release];
  task = nil;
}

- (id) name;
{
  return m_taskName;
}

- (id) directory
{
		return m_directory;
}

- (id) args
{
		return m_args;
}

- (NSMutableString *) output
{
	return m_taskOutput;	
}

- (int) exitStatus
{
		return m_exitStatus;
}

@end
