/*
 *  $Id: RRController.h,v 1.1.1.1 2002/11/09 15:44:02 omalley Exp $
 *  Copyright (c) 2002 Kevin O'Malley. All rights reserved.
 *
 *  Example program from "Programming Mac OS X: A Guide for
 *  UNIX Developers" by Kevin O'Malley, Manning Publishing
 *  2002.
 */
#import <Cocoa/Cocoa.h>
#import "WGetParameters.h"

@interface RRController : NSObject
{
  IBOutlet NSButton *backupBeforeConvert;
  IBOutlet NSButton *convertLinksToLocal;
  IBOutlet NSButton *deleteAfterDownload;
  IBOutlet NSForm *dirWhenDownloadForm;
  IBOutlet NSForm *fileFromDomainForm;
  IBOutlet NSForm *fileWithExtForm;
  IBOutlet NSButton *followFTPLinks;
  IBOutlet NSButton *followRelativeLinks;
  IBOutlet NSButton *getAllFiles;
  IBOutlet NSButton *getFilesBelowParent;
  IBOutlet NSButton *gotoForeginHosts;
  IBOutlet NSForm *HTMLTagsForm;
  IBOutlet NSButton *mirror;
  IBOutlet NSButton *noDNSLookup;
  IBOutlet NSPopUpButton *recursionDepth;
  IBOutlet NSButton *recursiveRetievalOn;
}

- (IBAction)reset:(WGetParameters *)param;
- (void)getParameters:(WGetParameters *)param;

enum FilesWithExtForm {
  AcceptExt = 0,
  DoNotAcceptExt
};

enum FilesFromDomainForm {
  AcceptDomain = 0,
  DoNotAcceptDomain
};

enum FollowHTMLTags {
  FollowHTMLTags = 0,
  DoNotFollowHTMLTags
};

enum FollowDirDownload {
  FollowDir = 0,
  DoNotFollowDir
};

@end
