/*
 *  $Id: RRController.m,v 1.1.1.1 2002/11/09 15:44:02 omalley Exp $
 *  Copyright (c) 2002 Kevin O'Malley. All rights reserved.
 *
 *  Example program from "Programming Mac OS X: A Guide for
 *  UNIX Developers" by Kevin O'Malley, Manning Publishing
 *  2002.
 */
#import "RRController.h"

@implementation RRController

- (IBAction)reset:(WGetParameters *)param
{
  [[fileWithExtForm cellAtIndex:AcceptExt] setStringValue:[param getValue:@"--accept="]];
    
  [[fileWithExtForm cellAtIndex:DoNotAcceptExt] setStringValue:[param getValue:@"--reject="]];

  [[fileFromDomainForm cellAtIndex:AcceptDomain] setStringValue:[param getValue:@"--domains="]];
  [[fileFromDomainForm cellAtIndex:DoNotAcceptDomain] setStringValue:[param getValue:@"--exclude-domains="]];

  [[dirWhenDownloadForm cellAtIndex:FollowDir] setStringValue:[param getValue:@"--include-directories="]];
  [[dirWhenDownloadForm cellAtIndex:DoNotFollowDir] setStringValue:[param getValue:@"--exclude-directories="]];

  [[HTMLTagsForm cellAtIndex:FollowHTMLTags] setStringValue:[param getValue:@"--follow-tags="]];
  [[HTMLTagsForm cellAtIndex:DoNotFollowHTMLTags] setStringValue:[param getValue:@"--ignore-tags="]];

  if ([[param getValue:@"--backup-converted"] isEqualToString:@"1"])
    [backupBeforeConvert setState:NSOnState];
  else
    [backupBeforeConvert setState:NSOffState];

  if ([[param getValue:@"--convert-links"] isEqualToString:@"1"])
    [convertLinksToLocal setState:NSOnState];
  else
    [convertLinksToLocal setState:NSOffState];

  if ([[param getValue:@"--delete-after"] isEqualToString:@"1"])
    [deleteAfterDownload setState:NSOnState];
  else
    [deleteAfterDownload setState:NSOffState];

  if ([[param getValue:@"--follow-ftp"] isEqualToString:@"1"])
    [followFTPLinks setState:NSOnState];
  else
    [followFTPLinks setState:NSOffState];

  if ([[param getValue:@"--relative"] isEqualToString:@"1"])
    [followRelativeLinks setState:NSOnState];
  else
    [followRelativeLinks setState:NSOffState];

  if ([[param getValue:@"--page-requisites"] isEqualToString:@"1"])
    [getAllFiles setState:NSOnState];
  else
    [getAllFiles setState:NSOffState];

  if ([[param getValue:@"--header"] isEqualToString:@"1"])
    [getFilesBelowParent setState:NSOnState];
  else
    [getFilesBelowParent setState:NSOffState];

  if ([[param getValue:@"--span-hosts"] isEqualToString:@"1"])
    [gotoForeginHosts setState:NSOnState];
  else
    [gotoForeginHosts setState:NSOffState];

  if ([[param getValue:@"--mirror"] isEqualToString:@"1"])
    [mirror setState:NSOnState];
  else
    [mirror setState:NSOffState];

  if ([[param getValue:@"--no-host-lookup"] isEqualToString:@"1"])
    [noDNSLookup setState:NSOnState];
  else
    [noDNSLookup setState:NSOffState];

  if ([[param getValue:@"--recursive"] isEqualToString:@"1"])
    [recursiveRetievalOn setState:NSOnState];
  else
    [recursiveRetievalOn setState:NSOffState];

  [recursionDepth selectItemAtIndex:[[param getValue:@"--level="] intValue]];
}

- (void)getParameters:(WGetParameters *)param
{
  NSString *s;

  [param setValue:@"--accept=":[[fileWithExtForm cellAtIndex:AcceptExt] stringValue]];
  [param setValue:@"--reject=":[[fileWithExtForm cellAtIndex:DoNotAcceptExt] stringValue]];
  [param setValue:@"--domains=":[[fileFromDomainForm cellAtIndex:AcceptDomain] stringValue]];
  [param setValue:@"--exclude-domains=":[[fileFromDomainForm cellAtIndex:DoNotAcceptDomain] stringValue]];

  [param setValue:@"--include-directories=":[[dirWhenDownloadForm cellAtIndex:FollowDir] stringValue]];
  [param setValue:@"--exclude-directories=":[[dirWhenDownloadForm cellAtIndex:DoNotFollowDir] stringValue]];

  [param setValue:@"--follow-tags=":[[HTMLTagsForm cellAtIndex:FollowHTMLTags] stringValue]];
  [param setValue:@"--ignore-tags=":[[HTMLTagsForm cellAtIndex:DoNotFollowHTMLTags] stringValue]];

  
  [param setValue:@"--backup-converted":[NSString stringWithFormat:@"%d", [backupBeforeConvert state]]];
  [param setValue:@"--convert-links":[NSString stringWithFormat:@"%d", [convertLinksToLocal state]]];
  [param setValue:@"--delete-after":[NSString stringWithFormat:@"%d", [deleteAfterDownload state]]];

  [param setValue:@"--follow-ftp":[NSString stringWithFormat:@"%d", [followFTPLinks state]]];
  [param setValue:@"--relative":[NSString stringWithFormat:@"%d", [followRelativeLinks state]]];
  [param setValue:@"--page-requisites":[NSString stringWithFormat:@"%d", [getAllFiles state]]];
  [param setValue:@"--header":[NSString stringWithFormat:@"%d", [getFilesBelowParent state]]];

  [param setValue:@"--span-hosts":[NSString stringWithFormat:@"%d", [gotoForeginHosts state]]];
  [param setValue:@"--mirror":[NSString stringWithFormat:@"%d", [mirror state]]];
  [param setValue:@"--no-host-lookup":[NSString stringWithFormat:@"%d", [noDNSLookup state]]];
  [param setValue:@"--recursive":[NSString stringWithFormat:@"%d", [recursiveRetievalOn state]]];


  s = [NSString stringWithFormat:@"%d", [recursiveRetievalOn state]];
  if ([s isEqualToString:@"1"]) {
    NSString *t = [NSString stringWithFormat:@"%@", [recursionDepth titleOfSelectedItem]];
    [param setValue:@"--level=":t];
  }
  else
    [param setValue:@"--level=":@"5"];
}

@end
