/*
 *  $Id: WGetParameters.m,v 1.1.1.1 2002/11/09 15:44:02 omalley Exp $
 *  Copyright (c) 2002 Kevin O'Malley. All rights reserved.
 *
 *  Example program from "Programming Mac OS X: A Guide for
 *  UNIX Developers" by Kevin O'Malley, Manning Publishing
 *  2002.
 */
#import "WGetParameters.h"


@implementation WGetParameters

- (id) init
{
  self = [super init]; 

  data = [[NSMutableDictionary alloc] init];
  [self initToDefaults];
	cmdLine = [[NSMutableString alloc] initWithString:@""];
  return self;
}

- (void) dealloc
{
  [data release]; 
  [cmdLine release]; 
  [super dealloc];
}

- (void)initToDefaults
{
  [data setObject:@"" forKey:@"--output-file="];  // logMsgForm:LogMsgTo
  [data setObject:@"" forKey:@"--append-output="];  // logMsgForm:AppendMsgTo
  [data setObject:@"" forKey:@"--input-file="];  // inputForm:DownloadUrlFrom
  [data setObject:@"" forKey:@"--base="];  // inputForm:PrependLinksWith
  [data setObject:@"" forKey:@"--quota="];  // limitDownloadSizeTo
  [data setObject:@"" forKey:@"--wait="];  // pauseBetweenRetrievals
  [data setObject:@"" forKey:@"--tries="];  // nRetries
  [data setObject:@"" forKey:@"--cut-dirs="];  // removeNDirComponent
  [data setObject:@"" forKey:@"--waitretry="];   // waitBetweenFailedRetrievals
  [data setObject:@"" forKey:@"--accept="];  // fileWithExtForm:AcceptExt
  [data setObject:@"" forKey:@"--reject="];  // fileWithExtForm:DoNotAcceptExt
  [data setObject:@"" forKey:@"--domains="];  // fileFromDomainForm:AcceptDomain
  [data setObject:@"" forKey:@"--exclude-domains="];  // fileFromDomainForm:DoNotAcceptDomain
  [data setObject:@"" forKey:@"--include-directories="];  // dirWhenDownloadForm:FollowDir
  [data setObject:@"" forKey:@"--exclude-directories="];  // dirWhenDownloadForm:DoNotFollowDir
  [data setObject:@"" forKey:@"--follow-tags="];  // HTMLTagsForm:FollowHTMLTags
  [data setObject:@"" forKey:@"--ignore-tags="];  // HTMLTagsForm:DoNotFollowHTMLTags
  [data setObject:@"" forKey:@"--load-cookies="];  // cookiesForm:Log
  [data setObject:@"" forKey:@"--save-cookies="];  // cookiesForm:Save
  [data setObject:@"" forKey:@"--header="];  // headersForm:Define
  [data setObject:@"" forKey:@"--referer="];  // headersForm:Include
  [data setObject:@"5" forKey:@"--level="];  // recursiveRetievalOn
  [data setObject:@"" forKey:@"--cookies="];  // disableCookies
  [data setObject:@"" forKey:@"--glob="];  // turnOffWildcards
  [data setObject:@"" forKey:@"--user-agent="];  // agentString
  [data setObject:@"" forKey:@"--directory-prefix="];  // outputDir
  [data setObject:@"" forKey:@"--proxy="];  // proxyOn
  [data setObject:@"" forKey:@"--cache="];  // getFilesfromRemoteSite
  [data setObject:@"" forKey:@"--output-document="];  // getFilesfromRemoteSite


  [data setObject:@"" forKey:@"extra-commands"];  // extraCommands
  [data setObject:@"" forKey:@"--force-html="];  // printDebugInfo
  [data setObject:@"" forKey:@"--debug"];  // treatInputFileAsHTML
  [data setObject:@"" forKey:@"--quiet"];  // turnOffOutput
  [data setObject:@"" forKey:@"--verbose"];  // turnVerboseOn
  [data setObject:@"" forKey:@"--no-directories"];  // getFilesNewerThan
  [data setObject:@"" forKey:@"-Q-size"];  // limitDownloadSizeType
  [data setObject:@"" forKey:@"--no-directories"];  // noDirCreateOnDownload
  [data setObject:@"" forKey:@"--no-host-directories"];  // noHostnamePrefix
  [data setObject:@"" forKey:@"--no-clobber"];  // overwriteFiles
  [data setObject:@"" forKey:@"--server-response"];  // printServerResponse
  [data setObject:@"" forKey:@"--continue"];  // resumeDownload
  [data setObject:@"" forKey:@"--spider"];  // spider

  [data setObject:@"" forKey:@"--backup-converted"];  // backupBeforeConvert
  [data setObject:@"" forKey:@"--convert-links"];  // convertLinksToLocal

  [data setObject:@"" forKey:@"--delete-after"];  // deleteAfterDownload
  [data setObject:@"" forKey:@"--follow-ftp"];  // followFTPLinks
  [data setObject:@"" forKey:@"--relative"];  // followRelativeLinks

  [data setObject:@"" forKey:@"--page-requisites"];  // getAllFiles
  [data setObject:@"" forKey:@"--header"];  // getFilesBelowParent
  [data setObject:@"" forKey:@"--span-hosts"];  // gotoForeginHosts
  [data setObject:@"" forKey:@"--mirror"];  // mirror
  [data setObject:@"" forKey:@"--no-host-lookup"];  // noDNSLookup
  [data setObject:@"" forKey:@"--recursive"];  // recursiveRetievalOn

  [data setObject:@"" forKey:@"--html-extension"];  // addHtmlExt
  [data setObject:@"" forKey:@"--no-http-keep-alive"];  // disablePersistentHtml
  [data setObject:@"" forKey:@"--cache"];  // disableServerCache
  [data setObject:@"" forKey:@"--dont-remove-listing"];  // doNotRemoveListingFile

  [data setObject:@"" forKey:@"--ignore-length"];  // ignoreContentLengthHeader
  [data setObject:@"" forKey:@"--retr-symlinks"];  // retierveFilesfromLinks
  [data setObject:@"" forKey:@"--save-headers"];  // saveHeaders
  [data setObject:@"" forKey:@"--passive-ftp"];  // usePassiveFtp

  [data setObject:@"" forKey:@"--timestamp"];  // noFilesUnlessNewerThanLocal  
  [data setObject:@"" forKey:@"raw-command"];  // raw command  
}

- (void)saveData:(NSString *)fname
{
  [data writeToFile:fname atomically:YES];
}

- (void)loadData:(NSString *)fname
{
  NSString *s = fname;
  s = [s stringByExpandingTildeInPath];
  [s retain];
  [data release]; 
  data = [[NSMutableDictionary alloc] initWithContentsOfFile:s];
  if (data == nil) {
    data = [[NSMutableDictionary alloc] init];
    [self initToDefaults];
  }
}

- (NSString *)getValue:(NSString *)key
{
  return [data objectForKey: key];
}

- (void)setValue:(NSString *)key: (NSString *)value
{
  [data setObject:value forKey:key];
}

- (void)printData
{
  NSArray *keys;
  int i, count;
  id key, value;
  
  keys = [data allKeys];
  count = [keys count];
  NSLog(@"-------");
  for (i = 0; i < count; i++) {
    key = [keys objectAtIndex: i];
    value = [data objectForKey: key];
    NSLog(@"Key: %@ Value: '%@'", key, value);
  }
  NSLog(@"-------");
}

- (NSMutableArray *)getData
{
  NSArray *keys;
  int i, count;
  id key, value;
  NSString *kStr = @"";
  NSString *vStr = @"";
  NSString *urlStr = @"";
  NSMutableArray *args = [[NSMutableArray alloc] init];
	BOOL rawCommand = NO;
	
	//[cmdLine setString:@"wget "];
  keys = [data allKeys];
  count = [keys count];
  for (i=0; i<count; i++) {
    key = [keys objectAtIndex: i];
    value = [data objectForKey: key];

    kStr = [NSString stringWithFormat:@"%@", key];
    vStr = [NSString stringWithFormat:@"%@", value];
		
    /*
     Construct the command for wget.  Set items, or values
     that are no "" or "0", are added to the command string.
     */
    if ( (![vStr isEqualToString:@""])
         && (![vStr isEqualToString:@"0"]) ) {

      if ([kStr isEqualToString:@"extra-commands"]) {
        [args addObject:[NSString stringWithFormat:@"%@", vStr]];
      }
      else if ([kStr isEqualToString:@"--quota="]) {
        NSString *s = [data objectForKey: @"Q-size"];
        [args addObject:[NSString stringWithFormat:@"%@=%@%@", kStr, vStr, s]];
      }
      else if ([kStr isEqualToString:@"url"]) {
        urlStr = [NSString stringWithFormat:@"%@", vStr];
        continue;
      }
      else if ([kStr isEqualToString:@"Q-size"]) {
      }
      else if ([kStr isEqualToString:@"raw-command"]) {
        NSLog(@"**");
				[args autorelease];
				args = [[NSMutableArray alloc] init];
				[args addObject:[NSString stringWithFormat:@"%@", vStr]];
				rawCommand = YES;
				break;
      }
      else if ([kStr isEqualToString:@"--tries="]) {       
        if ([vStr isEqualToString:@"Unlimited"]) {
          NSString *s = [NSString stringWithFormat:@"%d", 0];
          [args addObject:[NSString stringWithFormat:@"%@%@", kStr, s]];
        }
        else {
          [args addObject:[NSString stringWithFormat:@"%@%@", kStr, vStr]];         
        }
      }
      else {
        NSRange range = [kStr rangeOfString:@"="];
        int length = range.length;
        if (length == 0)  {
          [args addObject:[NSString stringWithFormat:@"%@", kStr]];
        }
        else {
          [args addObject:[NSString stringWithFormat:@"%@%@", kStr, vStr]];            
        }
      }
    } 
  }  // for

	if (!rawCommand) {
		if (![urlStr isEqualToString:@""]) {
			[args addObject:[NSString stringWithFormat:@"%@", urlStr]];
		}		
	}
	
  [args autorelease];
  return args;
}

- (NSMutableString *)getCommandLine
{
  return cmdLine;
}

- (void)formatCommandLine
{
  int i, count;
	NSString *s;
  NSMutableArray* theArray = [self getData];

	[cmdLine setString:@"wget "];
  count = [theArray count];
  for (i=0; i<count; i++) {
		s = [theArray objectAtIndex:i];
		[cmdLine appendString:[NSString stringWithFormat:@"%@ ", s]];
	}
}
@end
